from pathlib import Path

from pydantic import BaseSettings, validator

base_dir: Path = Path(__file__).resolve().parent


class Settings(BaseSettings):
    base_dir: Path = base_dir
    server_host: str = "127.0.0.1"
    server_port: int = 8000

    database_url: str
    database_type: str = None  # postgresql or sqlite, will be generated by validator from database_url

    token_expires_minutes: int = 60
    secret_key: str = "1ksksk@129djbqnsd%k12kaslk#"
    algorithm: str = "HS256"

    @validator("database_type")
    def database_type_validate(cls, _, values):
        return values["database_url"].lower().split(":")[0]

    class Config:
        env_file = f"{base_dir}/.env"
        env_file_encoding = "utf-8"


settings = Settings()
